package calendar;

import java.util.Calendar;
import java.util.Date;
import java.util.Enumeration;
import java.util.Vector;

import log.ILogger;
import log.Logger;

/**
 * Some static methods which I am used to having in modern Java
 * 
 * @author richard
 *
 */
public class OldJavaUtils {

	private final static ILogger LOG = Logger.get(OldJavaUtils.class);

	public interface Comparator {
		int compare(Object left, Object right);
	}
	
	/**
	 * Bubble sort. TODO: Replace please!
	 * 
	 * @param vector
	 * @param c
	 */
	public static void sort(Vector vector, Comparator c) {
		int elemCount = vector.size();

		for (int outIndex = elemCount - 1; outIndex > 1; outIndex--) { 
			for (int inIndex = 0; inIndex < outIndex; inIndex++) { 
				if (c.compare(vector.elementAt(inIndex), vector.elementAt(inIndex + 1)) > 0) {
					Object temp = vector.elementAt(inIndex);
					vector.setElementAt(vector.elementAt(inIndex + 1), inIndex);
					vector.setElementAt(temp, inIndex + 1);
				}
			}
		}
	}

	public static void sort(Object[] array, Comparator c) {
		int elemCount = array.length;

		for (int outIndex = elemCount - 1; outIndex > 1; outIndex--) { 
			for (int inIndex = 0; inIndex < outIndex; inIndex++) {
				if (c.compare(array[inIndex], array[inIndex + 1]) > 0) {
					Object temp = array[inIndex];
					array[inIndex] = array[inIndex + 1];
					array[inIndex + 1] = temp;
				}
			}
		}
	}

	public static Date stripTime(Date original) {
		final Calendar calendar = Calendar.getInstance();
		LOG.log("original " + original, ILogger.DEBUG);
		calendar.setTime(original);
		calendar.set(Calendar.HOUR_OF_DAY, 0);
		calendar.set(Calendar.MINUTE, 0);
		calendar.set(Calendar.SECOND, 0);
		calendar.set(Calendar.MILLISECOND, 0);
		Date newDate = calendar.getTime();
		LOG.log("result " + newDate, ILogger.DEBUG);
		return newDate;
	}

	public static Object[] copyIntoArray(Object[] source, Object[] dest) {
		for (int i = 0; i < source.length; i++) {
			dest[i] = source[i];
		}
		return dest;
	}

	public static Object[] toArray(Vector vector, Object[] array) {
		// Create splitted string array
		// final String[] result = new String[nodes.size()];
		if (vector.size() > 0) {
			for (int loop = 0; loop < vector.size(); loop++) {
				array[loop] = vector.elementAt(loop);
			}
		}
		return array;
	}

	public static Object[] toArray(Enumeration vector, Object[] array) {
		int i = 0;
		while (vector.hasMoreElements()) {
			array[i] = vector.nextElement();
			i++;
		}
		return array;
	}

	public static boolean contains(int[] array, int element) {
		for (int i = 0; i < array.length; i++) {
			if (array[i] == element)
				return true;
		}
		return false;
	}

	public static String[] split(String original, String token) {
		Vector nodes = new Vector();
		// Parse nodes into vector
		int index = original.indexOf(token);
		while (index >= 0) {
			nodes.addElement(original.substring(0, index));
			original = original.substring(index + 1);
			index = original.indexOf(token);
		}
		// Get the last node
		nodes.addElement(original);
		return (String[]) OldJavaUtils.toArray(nodes, new String[nodes.size()]);
	}

	public static String[] splitByAny(String original, char[] seperators) {
		Vector nodes = new Vector();
		// Parse nodes into vector
		int nextSeperator = -1;
		for (int seperatorIndex = 0; seperatorIndex < seperators.length; seperatorIndex++) {
			int thisSeperator = original.indexOf(seperators[seperatorIndex]);
			if (nextSeperator == -1 || nextSeperator > thisSeperator) {
				nextSeperator = thisSeperator;
			}
		}

		while (nextSeperator >= 0) {
			nodes.addElement(original.substring(0, nextSeperator));
			original = original.substring(nextSeperator + 1);
			nextSeperator = original.indexOf(nextSeperator);
		}
		// Get the last node
		nodes.addElement(original);
		return (String[]) OldJavaUtils.toArray(nodes, new String[nodes.size()]);
	}

	public static String[] splitIntoLines(String original) {
		Vector nodes = new Vector();
		// Parse nodes into vector
		int index = nextLineSeperator(original);
		while (index >= 0) {
			nodes.addElement(original.substring(0, index));
			original = original.substring(index + 1);
			index = nextLineSeperator(original);
		}
		// Get the last node
		nodes.addElement(original);
		return (String[]) OldJavaUtils.toArray(nodes, new String[nodes.size()]);
	}

	public static int nextLineSeperator(String original) {
		int Nindex = original.indexOf("\n");
		int Rindex = original.indexOf("\r");
		return Nindex < Rindex ? Nindex : Rindex;
	}
}
