package calendar;

import java.util.Date;

import calendar.objectmodel.IEventDescription;
import calendar.objectmodel.IEventInstance;

public class SingleInstanceEvent implements IEventInstance {

	private final IEventDescription original;

	public SingleInstanceEvent(IEventDescription original) {
		this.original = original;
	}

	public String getDescription() {
		return original.getDescription();
	}

	public Date getEnd() {
		return original.getEnd();
	}

	public String getLocation() {
		return original.getLocation();
	}

	public Date getStart() {
		return original.getStart();
	}

	public String getTitle() {
		return original.getTitle();
	}

	public String toString() {
		return "SingleInstanceEvent[" + getTitle() + ", " + getStart() + "]";
	}
}
