package calendar;

/**
 * Support for "caused by" exceptions
 * 
 * @author richard
 *
 */
public class WrappingException extends RuntimeException {

	private final Throwable causedBy;

	public WrappingException() {
		super();
		causedBy = null;
	}

	public WrappingException(String message) {
		super(message);
		causedBy = null;
	}

	public WrappingException(String message, Throwable causedBy) {
		super(message);
		this.causedBy = causedBy;
	}

	public void printStackTrace() {
		super.printStackTrace();
		System.err.println("Caused by:");
		causedBy.printStackTrace();
	}

	public String toString() {
		return "WrappingException(" + causedBy + ")";
	}

	public String getMessage() {
		return "WrappingException(" + super.getMessage() + ")";
	}
}
