package calendar.objectmodel;

import java.util.Date;

/**
 * Represents an event or event series in a calendar. It may be a one off event, or
 * the first event in a series (as described by the IRepeatRule).
 * 
 * @author richard
 *
 */
public interface IEventDescription {
	IRepeatRule getRepeatRule();
	String getTitle();
	String getDescription();
	Date getStart();
	Date getEnd();
	String getLocation();
}