package calendar.objectmodel;

import java.util.Date;

/**
 * Limited support for event repeating. The ICal format (RFC 2445) supports much more
 * complex repeat rules, which need to be reflected here.
 * 
 * @author richard
 *
 */
public interface IRepeatRule {

	public int getFrequency();
	public Date getUntil();
	public int getDays();
	
	public final static int FREQUENCY_DAILY = 1;
	public final static int FREQUENCY_WEEKLY = 2;
	public final static int FREQUENCY_MONTHLY = 3;
	
	public final static int DAY_MONDAY = 1;
	public final static int DAY_TUESDAY= 2;
	public final static int DAY_WEDNESDAY = 4;
	public final static int DAY_THURSDAY = 8;
	public final static int DAY_FRIDAY = 16;
	public final static int DAY_SATURDAY = 32;
	public final static int DAY_SUNDAY = 64;
}
