package calendar.objectmodel;

import java.util.Date;

public class ImmutableEvent implements IEventDescription {
	private final Date start, end;

	private final String title;

	private final IRepeatRule repeatRule;

	private final String description, location;

	public ImmutableEvent(String title, String description, String location, Date start, Date end,
			IRepeatRule repeatRule) {
		this.start = start;
		this.end = end;
		this.title = title;
		this.description = description;
		this.repeatRule = repeatRule;
		this.location = location;
	}

	public String getTitle() {
		return title;
	}

	public Date getStart() {
		return start;
	}

	public Date getEnd() {
		return end;
	}

	public IRepeatRule getRepeatRule() {
		return repeatRule;
	}

	public String toString() {
		return "Event(Title = " + title + ";Start = " + start + ";Repeat = " + repeatRule + ")";
	}

	public String getDescription() {
		return description;
	}

	public String getLocation() {
		return location;
	}
}
