package calendar.objectmodel;

import java.util.Date;

public class ImmutableRepeatRule implements IRepeatRule {

	private final int frequency;

	private final Date until;

	private final int days;

	public ImmutableRepeatRule(int frequency, Date until, int days) {
		this.frequency = frequency;
		this.until = until;
		this.days = days;
	}

	public int getFrequency() {
		return frequency;
	}

	public Date getUntil() {
		return until;
	}

	public int getDays() {
		return days;
	}

	public String toString() {
		return "Repeat(Until = " + until + "; Days = " + days + "; Frequency = " + frequency + ")";
	}
}
