package calendarsourceentries;

import log.ILogger;
import calendar.CalendarSource;
import calendar.FileConnectionCalendarSource;
import calendar.ICalCalendarParser;
import calendar.ICalendarSource;

public class CalendarFileSourceEntry extends CalendarSourceEntry {
	private final String filename, root;

	public static final String MARKER = "FILE";

	public CalendarFileSourceEntry(String name, String root, String filename) {
		super(name);
		this.root = root;
		this.filename = filename;
	}

	public ICalendarSource[] createSources(ILogger log) {
		return new ICalendarSource[] { new CalendarSource(new FileConnectionCalendarSource("file://" + root + "/"
				+ filename), ICalCalendarParser.INSTANCE) };
	}

	public static CalendarFileSourceEntry parse(String name, String[] data) {
		return new CalendarFileSourceEntry(name, data[0], data[1]);
	}

	protected String getMarker() {
		return MARKER;
	}

	protected String[] internalSerialize() {
		return new String[] { root, filename };
	}

	public String getFilename() {
		return filename;
	}

	public String getRoot() {
		return root;
	}
}
