package calendarsourceentries;

import java.util.Vector;

import javax.microedition.rms.RecordEnumeration;
import javax.microedition.rms.RecordStore;

import calendar.WrappingException;

import log.ILogger;

public class CalendarSourceEntryStore {

	private static final String CALENDAR_RECORD_NAME = "mycalendars";

	// CalendarSourceHolder
	public static Vector loadCalendarEntries() {
		try {
			final Vector calendars = new Vector();
			final RecordStore rs = RecordStore.openRecordStore(CALENDAR_RECORD_NAME, true);

			for (final RecordEnumeration re = rs.enumerateRecords(null, null, false); re.hasNextElement();) {
				final byte[] calendarInfo = re.nextRecord();
				System.out.println("Calendar info");
				final CalendarSourceEntry sourceEntry = CalendarSourceEntry.parse(calendarInfo);
				calendars.addElement(new CalendarSourceHolder(sourceEntry));
			}

			rs.closeRecordStore();
			return calendars;
		} catch (Exception e) {
			e.printStackTrace();
			throw new RuntimeException(e.getMessage());
		}
	}

	public static void saveCalendars(final Vector calendars, ILogger log) {
		if (calendars != null) {
			try {
				log.log("Opening record store", ILogger.DEBUG);
				final RecordStore rs = RecordStore.openRecordStore(CALENDAR_RECORD_NAME, true);
				log.log("Clearing record store", ILogger.DEBUG);
				for (final RecordEnumeration re = rs.enumerateRecords(null, null, false); re.hasNextElement();) {
					int recordId = re.nextRecordId();
					log.log("deleting " + recordId, ILogger.DEBUG);
					rs.deleteRecord(recordId);
				}

				System.out.println("adding records");
				for (int calendarIndex = 0; calendarIndex < calendars.size(); calendarIndex++) {
					final CalendarSourceHolder calendar = (CalendarSourceHolder) calendars.elementAt(calendarIndex);
					final CalendarSourceEntry entry = calendar.getEntry();
					log.log("serializing record", ILogger.DEBUG);
					final byte[] calendarSerialized = entry.serialize();
					log.log("writing record", ILogger.DEBUG);
					rs.addRecord(calendarSerialized, 0, calendarSerialized.length);
				}
			} catch (Exception e) {
				throw new WrappingException("Error saving calendars", e);
			}
		}
	}
}
