package log;

public class ContextAppendingLogger implements ILogger {

	public ContextAppendingLogger(ILogger wrapped) {
		this.wrapped = wrapped;
	}
	
	private static final String WARNING_TAGS[] = new String[] { "Unknown", "Info", "Warning", "Error", "Debug" };

	private final ILogger wrapped;

	public void log(String message, int severity) {
		wrapped.log(WARNING_TAGS[severity] + ":" + message, severity);
	}

	public void close() {
		wrapped.close();
	}
}
