package log;

public class FilteringLogger implements ILogger {

	private final ILogger wrapped;
	private final int minimumLevel;

	public FilteringLogger(int minimumLevel, ILogger wrapped) {
		this.wrapped = wrapped;
		this.minimumLevel = minimumLevel;
	}

	public void close() {
		wrapped.close();
	}

	public void log(String message, int severity) {
		if (severity >= minimumLevel)
			wrapped.log(message, severity);
	}
}
