package log;

public class Logger {

	private static ILogger GLOBAL_LOGGER;

	private static class GlobalLoggerFascade implements ILogger {
		private final Class requester;

		public GlobalLoggerFascade(Class requester) {
			this.requester = requester;
		}

		public void close() {
		}

		public void log(String message, int severity) {
			synchronized (Logger.class) {
				if (GLOBAL_LOGGER == null)
					throw new RuntimeException("Logger NOT INITIALIZED for " + message);
				GLOBAL_LOGGER.log(requester.getName() +": "+ message, severity);
			}
		}
	}

	public synchronized static ILogger get(Class requester) {
		return new GlobalLoggerFascade(requester);
	}

	public synchronized static void setDefault(ILogger logger) {
		GLOBAL_LOGGER = logger;
	}
}
