package log;

public class NullLogger implements ILogger {

	private NullLogger() {
	}

	private static ILogger instance = null;

	public static synchronized ILogger getInstance() {
		if (instance == null)
			instance = new NullLogger();
		return instance;
	}

	public void log(String message, int severity) {
	}

	public void close() {
	}
}
