package log;

import java.io.DataOutputStream;
import java.io.IOException;
import java.io.OutputStream;
import java.io.OutputStreamWriter;

public class OutputStreamLogger implements ILogger {

	private final OutputStreamWriter outputStreamWriter;

		public OutputStreamLogger(OutputStream outputStream) {
		outputStreamWriter = new OutputStreamWriter(outputStream);
	}

	public void close() {
		try {
			// outputStream.close();
			outputStreamWriter.close();
		} catch (IOException e) {
			throw new RuntimeException(e.getMessage());
		}
	}

	public synchronized void log(String message, int severity) {
		try {
			outputStreamWriter.write(message + "\n");
		} catch (IOException e) {
			throw new RuntimeException(e.getMessage());
		}
	}
}
