package phonecalendar;

import javax.microedition.lcdui.Command;
import javax.microedition.lcdui.CommandListener;
import javax.microedition.lcdui.Displayable;
import javax.microedition.lcdui.Form;

import calendar.objectmodel.IEventInstance;

public class EventDescriptionForm extends Form {

	private static Command BACK_COMMAND = new Command("Back", Command.BACK, 0);

	private FormClosedListener closedListener;

	public EventDescriptionForm() {
		super("");
		addCommand(BACK_COMMAND);

		setCommandListener(new CommandListener() {
			public void commandAction(Command command, Displayable arg1) {
				System.out.println("Event description form got message");

				if (command == BACK_COMMAND) {
					System.out.println("Event description form got backwards");
					closedListener.closed(FormClosedListener.RESULT_OK);
				}
			}
		});
	}

	public void setEvent(IEventInstance event) {
		System.out.println("Setting event description form");
		setTitle(event.getTitle());
		System.out.println("Set title of description form");

		deleteAll();

		String message = event.getTitle();

		if (event.getLocation() != null)
			message = message + "\nLocation: " + event.getLocation();

		if (event.getDescription() != null)
			message = message + "\nDescription: " + event.getDescription();

		append(message);
	}

	public void setFormClosedListener(FormClosedListener closedListener) {
		this.closedListener = closedListener;
	}
}
